#include "mbed.h"
#include <stdlib.h>
#include "bg96.h"

UnbufferedSerial pc(USBTX, USBRX, 115200);
BufferedSerial modem_int(PA_9, PA_10, 115200);

//Defino la interfaz UART "pc" como salida estándar
FileHandle *mbed::mbed_override_console(int fd)
{
    return &pc;
}

//Creo objeto bg96 (Pin Tx, Pin Rx, Pin Regulador, Pin PowKey)
bg96 bg96(PA_9, PA_10, PB_6, PB_15);

DigitalOut led1(PC_8);
DigitalOut led2(PB_13);

//Defino buffer para la recepción de mensajes por mqtt
char msg_rx[120];

char test_apn[] = "";              //APN MQTT
char oper[] = "";                      //Usuario MQTT
char test_topic_pub[] = "\"sutopico\""; //Topic MQTT para publicar
char test_topic_sub[] = "\"sutopico\"";     //Topic MQTT para subscripción
char mqtt_user[] = "\"miusuario\"";            //Usuario MQTT
char mqtt_pass[] = "\"mipass\"";            //Usuario MQTT

char msg_mqtt[] = "Prueba automatica de envio mqtt mundo desde el Kit_IoT!!";

int main()
{
    //Configuración de parámetros MQTT
    bg96.setAPN(test_apn);
    bg96.setOPER(oper);
    bg96.setMqttUser(mqtt_user);
    bg96.setMqttPass(mqtt_pass);
    bg96.setPubMqttTopic(test_topic_pub);
    bg96.setSubMqttTopic(test_topic_sub);

    printf("BG96 Library Example...\n");

    bg96.turn_on(); //Enciendo modem BG96

    ThisThread::sleep_for(2s);

    //Función de configuración inicial del modem (ver wiki NB-IoT Básico)
    bg96.configInit();

    //Obtengo hora UTC de la red celular y la cargo en el RTC del Core
    bg96.setRTCTime();

    //Función de configuración de parámetros mqtt (ver wiki NB-IoT Básico)
    bg96.mqttConfig();

    //Publico mensaje mqtt
    //Parámetros: Mensaje, QoS, Retain, MsgID
    bg96.sendMqttMsg(msg_mqtt, '0', '0', 0);

    printf("Fin de Test MQTT\n");
}
